Subject: Re: [lamps] [EXTERNAL]Re: [CMP Algorithms] Use Key-Wrap with or without padding in Section 4.3 and Section 5

From: Mike Ounsworth <[email-masked]>
Date: Tue, 19 Jan 2021 23:28:52 +0000

Hello Russ,

We would like to confirm our understanding of your comment below.

There are two encryption operations at play here:

- Content encryption; this key is encrypted with the keyWrap algorithm and included in the message.
- KeyWrap encryption; this key is established using one of the listed key establishment mechanisms.

Your suggestion (matching 8551) is that both encryptions MUST use the same algorithm and key size.

Therefore, the key to be wrapped, and the AESKeyWrap's block size will always be the same. Therefore, there is no reason to support a padded AES scheme.

Can you confirm that this is the correct understanding?

---
Mike Ounsworth
Hendrix Brockhaus
John Gray

-----Original Message-----
From: Spasm <[email-masked]> On Behalf Of Russ Housley
Sent: October 26, 2020 1:53 PM
To: Brockhaus, Hendrik <[email-masked]>
Cc: [email-masked]
Subject: [EXTERNAL]Re: [lamps] [CMP Algorithms] Use Key-Wrap with or without padding in Section 4.3 and Section 5

WARNING: This email originated outside of Entrust.
DO NOT CLICK links or attachments unless you trust the sender and know the content is safe.

> On Oct 26, 2020, at 1:12 PM, Brockhaus, Hendrik <[email-masked]> wrote:
> 
> I am looking for some guidance regarding encryption algorithms required for CMP, especially when using EnvelopedData.
> 
> Encryption is needed for encryption of the content-encryption key and for encryption of the content itself. 
> In case of CMP the content is a Signed Data wrapped AsymmetricKeyPackage, a Certificates or a Password.
> 
> I am uncertain whether to use AES key wrapping with or without padding?
> I am also uncertain if I can uses the same algorithm for CEK and content encryption?
> 
> Any guidance is welcome.
> 
> Hendrik

It seems that alignment with RFC 8551 would be a reasonable way forward, which would use different algorithms for key wrap and content encryption:

   The underlying encryption functions for the key wrap and content-
   encryption algorithms [RFC3370] [RFC3565] and the key sizes for the
   two algorithms MUST be the same (e.g., AES-128 key wrap algorithm
   with AES-128 content-encryption algorithm).  As both 128-bit and
   256-bit AES modes are mandatory to implement as content-encryption
   algorithms (Section 2.7), both the AES-128 and AES-256 key wrap
   algorithms MUST be supported.

Russ
_______________________________________________
Spasm mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/spasm

---

From: Russ Housley <[email-masked]>
Date: Tue, 19 Jan 2021 18:32:16 -0500

Yes, that is my suggestion.

Russ

> On Jan 19, 2021, at 6:28 PM, Mike Ounsworth <Mike.Ounsworth=[email-masked]> wrote:
> 
> Hello Russ,
>